<template>
  <div>
    <el-card>
      <el-form :model="filterQuery" size="mini" label-width="100px" v-if="showSearch">
        <el-row>
          <el-col :span="8">
            <el-form-item label="单据号:">
              <el-input v-model="filterQuery.billNo" style="width: 90%" placeholder="请输入单据号" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="外部系统:">
              <el-select v-model="filterQuery.thirdSysFk" style="width: 90%" placeholder="请选择第三方系统"
                         clearable="true" @change="thirdSysChange">
                <el-option
                  v-for="item in thirdSys"
                  :key="item.thirdId"
                  :label="item.thirdName"
                  :value="item.thirdId">
                  <span style="float: left;font-size: 13px">{{ item.thirdName }}</span>
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="单据类型:">
              <el-select v-model="filterQuery.billType" style="width: 90%" placeholder="请选择第三方系统单据类型"
                         clearable="true">
                <el-option
                  v-for="item in originTypes"
                  :key="item.name"
                  :label="item.name"
                  :value="item.action">
                  <span style="float: left;font-size: 13px">{{ item.name }}</span>
                  <span style="float: right; color: #8492a6; font-size: 13px;margin-left: 10px">{{
                      item.thirdSysName
                    }}</span>
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>


        </el-row>
        <el-row>
          <el-col :span="8">
            <el-form-item label="患者信息:">
              <el-input v-model="filterQuery.sicker" style="width: 90%" placeholder="请输入患者信息" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="单据日期:">
              <el-date-picker
                :picker-options="pickerOptions"
                v-model="actDateRange"
                type="daterange"
                format="yyyy 年 MM 月 dd 日"
                value-format="yyyy-MM-dd"
                range-separator="至"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="8" >
            <el-form-item label="收费日期:">
              <el-date-picker
                :picker-options="pickerOptions"
                v-model="chargeDateRange"
                type="daterange"
                format="yyyy 年 MM 月 dd 日"
                value-format="yyyy-MM-dd"
                range-separator="至"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>

      </el-form>

      <div class="top-right-btn">
        <el-button-group style="display:flex;">
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
          <el-button type="primary" icon="el-icon-search" @click="getList">查询</el-button>
          <el-button type="primary" icon="el-icon-search" @click="dlThrInvOrder">下载</el-button>
        </el-button-group>
      </div>

      <el-divider style="margin: 15px"></el-divider>
      <el-table v-loading="loading" :data="list" style="width: 100%" border highlight-current-row
                @current-change="handleDetail">
        <el-table-column label="序号" type="index" width="60"></el-table-column>
        <el-table-column label="单据号" prop="billNo"></el-table-column>
        <el-table-column label="单据时间" prop="billDate"></el-table-column>
        <el-table-column label="出入库类型" prop="mainAction">
          <template slot-scope="scope">
            <el-tag
              :type="scope.row.mainAction == 'WareHouseOut' ? 'primary' : 'success'"
              disable-transitions>{{scope.row.mainAction == 'WareHouseOut' ? '出库':'入库'}}</el-tag>
          </template>
        </el-table-column>
        <el-table-column label="第三方单据类型" prop="billType">
          <template slot-scope="scope">
            <el-tag
              :type="scope.row.mainAction == 'WareHouseOut' ? 'primary' : 'success'"
              disable-transitions>{{scope.row.mainAction == 'WareHouseOut' ? '出库':'入库'}}</el-tag>
          </template>
        </el-table-column>
        <el-table-column label="外部系统" prop="thirdSysFk"></el-table-column>
        <el-table-column label="患者编号" prop="sickerCode"></el-table-column>
        <el-table-column label="患者姓名" prop="sickerName"></el-table-column>
        <el-table-column label="收费时间" prop="chargeTime"></el-table-column>
<!--        <el-table-column label="收费人员" prop="chargeUser"></el-table-column>-->
<!--        <el-table-column label="单据状态" prop="status"></el-table-column>-->
        <el-table-column
          prop="status"
          label="单据状态"
          width="160"
          filter-placement="bottom-end">
          <template slot-scope="scope">
            <el-tag
              :type="scope.row.status == '1' ? 'primary' : 'success'"
              disable-transitions>{{scope.row.status == 0 ? '待生成':'已生成'}}</el-tag>
          </template>
        </el-table-column>
        <el-table-column label="异常信息" prop="exMsg"  width="360">
          <template v-slot="{ row }">
            <el-tooltip class="item" effect="dark" :content="row.exMsg" placement="top">
              <div class="ellipsis-text" :style="{ color: row.exMsg ? 'red' : 'red' } ">{{ row.exMsg }}</div>
            </el-tooltip>
          </template>
        </el-table-column>
        <el-table-column label="相关单据号" prop="toBillNo"></el-table-column>
        <el-table-column label="操作" width="160">
          <template slot-scope="scope">
            <el-button type="text" @click.native.stop="deleteDialog(scope.row)"
            >删除
            </el-button>
            <el-button v-show="scope.row.status == 0 && (scope.row.exMsg === null || scope.row.exMsg === '')" type="text" @click.native.stop="generateBill(scope.row)" STYLE="color:rgb(0,0,255)"
            >生成单据
            </el-button>
            <el-button v-show="scope.row.status == 1 && (scope.row.exMsg === null || scope.row.exMsg === '')" type="text" @click.native.stop="generateBill(scope.row)" STYLE="color:rgb(0,220,255)"
            >重新生成
            </el-button>
            <el-button v-show="scope.row.exMsg !== null && scope.row.exMsg !== ''" type="text" @click.native.stop="refreshGhBill(scope.row)"
            >更新
            </el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="filterQuery.page"
        :limit.sync="filterQuery.limit"
        @pagination="getList"
      />
    </el-card>
    <el-card class="el-card">
      <el-table v-loading="loading" :data="detailList" width="100%" :row-style="changRed" border highlight-current-row>
        <el-table-column label="序号" type="index" width="120"></el-table-column>
<!--        <el-table-column label="物资编码" prop="relId"></el-table-column>-->
<!--        <el-table-column label="第三方项目编码" prop="thrCode"></el-table-column>-->
        <el-table-column label="UDI" prop="udiCode"></el-table-column>
        <el-table-column label="DI/物资编码" prop="nameCode"></el-table-column>
        <el-table-column label="产品通用名" prop="cpmctymc" show-overflow-tooltip="true"></el-table-column>
<!--        <el-table-column label="DI" prop="nameCode" show-overflow-tooltip="true"></el-table-column>-->
        <el-table-column label="规格型号" prop="ggxh" show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="批次号" prop="batchNo"></el-table-column>
        <el-table-column label="序列号" prop="serialNo"></el-table-column>
        <el-table-column label="计量单位" prop="measname"></el-table-column>
        <el-table-column label="价格" prop="price"></el-table-column>
<!--        <el-table-column label="生产日期" prop="productDate"></el-table-column>-->
<!--        <el-table-column label="失效日期" prop="expireDate"></el-table-column>-->

        <el-table-column label="医疗器械注册备案人" prop="ylqxzcrbarmc"></el-table-column>
        <el-table-column label="注册/备案号" prop="zczbhhzbapzbh"></el-table-column>

        <el-table-column label="入库数量" prop="inCount"></el-table-column>
        <el-table-column label="出库数量" prop="outCount"></el-table-column>
        <el-table-column label="实际数量" prop="reCount"></el-table-column>
        <el-table-column label="相关单据号" prop="toBillNo"></el-table-column>
        <el-table-column label="操作" width="60">
          <template slot-scope="scope">
            <el-button type="text" @click.native.stop="deleteDetailDialog(scope.row)"
            >删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>
    </el-card>

    <el-dialog
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      title="生成单据"
      :visible.sync="thrInvOrderGenerateVisible"
      width="60%"
      v-if="thrInvOrderGenerateVisible"
      :close="closeAddDialog"
      class="dialog-two"
      top="5vh"
    >

      <thrInvOrderGenerate
        :generateOrderDate=thisData
        :originTypes=originTypes
        :sourceType = 3
        :closeAddDialog="closeAddDialog">
      </thrInvOrderGenerate>
    </el-dialog>
  </div>
</template>
<script>
import {
  delThrInvOrder,
  getThrInvOrders,
  getThrInvOrderDetails,
  delThrInvOrderDetail,
  refreshGhBill,
  dlThrInvFeeOrder, dlInvGhOrder
} from "@/api/thrsys/thrInvOrder";
import {getBussinessType} from "@/api/basic/bussinessType";
import {getOriginBusType} from "@/api/basic/busOriginType";
import {getBasicThirdSys, filterDetailByKey} from "@/api/basic/basicThirdSys";
import {selectIp} from "@/api/param/systemParamConfig";
import thrInvOrderGenerate from "@/views/thirdSys/invOrder/thrInvOrderGenerate";
import moment from "moment";

export default {
  data() {
    return {
      thisData:null,
      showSearch: true,
      filterQuery: {
        sicker: "",
        billType: null,
        billNo: "",
        // originType: null,
        thirdSysFk: "",
        sourceType: 3,
        page: 1,
        limit: 10,
        // corpName: null,
      },
      thrInvOrderGenerateVisible: false,
      total: 0,
      thirdSys: [],
      thirdSysDetail: null,
      busTypes: [],
      originTypes: [],
      list: [],
      detailList: [],
      uploadFileUrl: null,
      fileList: [],
      uploadData: {
        thirdSys: "thirdId",
      },
      loading: false,
      actDateRange: [],
      chargeDateRange: [],
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
    };
  },
  methods: {
    refreshGhBill(row){
      let rQuery = {
        billNo: row.billNo,
      };
      refreshGhBill(rQuery)
        .then((response) => {
          this.loading = false;
          if (response.code == 20000) {
            this.$message.success("更新成功");
            this.getList();
          } else {
            this.$message.error(response.message);
          }
        })
        .catch(() => {
          this.loading = false;
        });
    },
    changRed({row}){
      if (row.relId == null) { // 变颜色的条件
        return {
          color: "red"  // 这个return的就是样式 可以是color 也可以是backgroundColor
        }
      }
    },
    onReset() {
      this.$router.push({
        path: "",
      });
      this.filterQuery = {
        billNo: "",
        thirdSysFk: "",
        sourceType: 3,
        // billFlag: null,
        billType: null,
        startDate: null,
        endDate: null,
        page: 1,
        limit: 10,
        // corpName: null,
      };
      this.actDateRange = [];
      this.getList();
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    getList() {
      if (this.filterQuery.thirdSysFk == null) {
        this.$message.warning("请先选择第三方系统！")
        return;
      }
      if (this.actDateRange != null) {
        this.filterQuery.startDate = this.actDateRange[0];
        this.filterQuery.endDate = this.actDateRange[1];
      } else {
        this.filterQuery.startDate = null;
        this.filterQuery.endDate = null;
      }
      if (this.chargeDateRange != null) {
        this.filterQuery.chargeStartDate = this.chargeDateRange[0];
        this.filterQuery.chargeEndDate = this.chargeDateRange[1];
      } else {
        this.filterQuery.chargeStartDate = null;
        this.filterQuery.chargeEndDate = null;
      }
      this.loading = true;
      getThrInvOrders(this.filterQuery)
        .then((response) => {
          if (response.code == 20000) {
            this.list = response.data.list || [];
            this.total = response.data.total || 0;
          } else {
            this.$message.error(response.message);
          }
          this.loading = false;
        })
        .catch(() => {
          this.loading = false;
          this.list = [];
          this.total = 0;
        });
    },
    handleDetail(row) {
      if (row ==null) return;
      let query = {orderIdFk: row.billNo};
      getThrInvOrderDetails(query)
        .then((response) => {
          if (response.code == 20000) {
            this.detailList = response.data.list || [];
          } else {
            this.$message.error(response.message);
          }
          this.loading = false;
        })
        .catch(() => {
          this.loading = false;
        });

    },
    generateBill(row){
      this.thisData = row;
      this.thrInvOrderGenerateVisible = true;
    },
    deleteDialog(row) {
      this.$confirm("此操作将永久删除该单据, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          let dQuery = {
            billNo: row.billNo,
          };
          delThrInvOrder(dQuery)
            .then((response) => {
              this.loading = false;
              if (response.code == 20000) {
                this.$message.success("删除成功");
                this.getList();
              } else {
                this.$message.error(response.message);
              }
            })
            .catch(() => {
              this.loading = false;
            });

        })
        .catch(() => {
        });
    },
    deleteDetailDialog(row){
      this.$confirm("此操作将永久删除该单据明细行, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          let dQuery = {
            id: row.id,
          };
          delThrInvOrderDetail(dQuery)
            .then((response) => {
              this.loading = false;
              if (response.code == 20000) {
                this.$message.success("删除成功");
                row.billNo = row.orderIdFk;
                this.handleDetail(row);
              } else {
                this.$message.error(response.message);
              }
            })
            .catch(() => {
              this.loading = false;
            });

        })
        .catch(() => {
        });
    },
    getBasicThirdSys() {
      let query = {
        enabled: true,
      };
      getBasicThirdSys(query)
        .then((response) => {
          this.thirdSys = response.data.list || [];
          this.filterQuery.thirdSysFk = this.thirdSys[0].thirdId;
          this.uploadData.thirdSys = this.filterQuery.thirdSysFk;
          this.selectSysParam();
          this.getThirdSysDetail();
          this.getBusType();
        })
        .catch(() => {
          this.loading = false;
          this.list = [];
        });
    },
    handleChange(response, files, fileList) {
      console.log(response);
      if (response.code != 20000) {
        this.$message.error(response.message);
      } else {
        console.log(files[0] + "\n" + this.fileList[0] + "\n" + fileList[0]);
        this.$message.success("文件上传成功,请稍后刷新查看！");
      }
    },
    selectSysParam() {
      let query = {
        key: "thirdIpUrl",
        thirdSysFk: this.filterQuery.thirdSysFk
      };
      selectIp(query).then((response) => {
        if (response.code == 20000) {
          this.uploadFileUrl = response.data.thridUrl + "/udiwms/erp/pi/upload";
        }
      });
    },
    thirdSysChange() {
      this.uploadData.thirdSys = this.filterQuery.thirdSysFk;
      this.getThirdSysDetail();
      this.filterQuery.billAction = "";
      this.getBusType();
    },
    getThirdSysDetail() {
      let query = {
        thirdSysFk: this.filterQuery.thirdSysFk,
        key: "orderQueryUrl",
      };
      filterDetailByKey(query)
        .then((response) => {
          this.thirdSysDetail = response.data;
        })
        .catch(() => {
          this.loading = false;
          this.list = [];
        });

    },

    getActionName(action) {
      for (let i = 0; i < this.busTypes.length; i++) {
        if (this.busTypes[i].action === action) {
          return this.busTypes[i].name;
        }
      }
    },

    getlocalName(action) {
      for (let i = 0; i < this.busTypes.length; i++) {
        if (this.busTypes[i].action === action) {
          return this.busTypes[i].localName;
        }
      }
    },
    getBusType() {
      let query = {
        enabled: true,
        thirdSys: this.filterQuery.thirdSysFk,
      };
      getBussinessType(query)
        .then((response) => {
          this.busTypes = response.data.list || [];
          this.getList();
        })
        .catch(() => {
        });
      getOriginBusType(query)
        .then((response) => {
          this.originTypes = response.data.list || [];
          // this.filterQuery.originType = this.originTypes[0].action;
          // this.getList();
        })
        .catch(() => {
        });
    },
    closeAddDialog(val) {
      this.thrInvOrderGenerateVisible = false;
      if (val) {
        this.getList();
      }
    },
    /**
     * 手动下载第三方出入库明细
     */
    dlThrInvOrder() {
      if (this.actDateRange != null) {
        this.filterQuery.startDate = this.actDateRange[0];
        this.filterQuery.endDate = this.actDateRange[1];
      }

      this.$confirm("是否确定下载日期范围为：" + this.filterQuery.startDate + "-----" + this.filterQuery.endDate + "的出入库明细？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          dlInvGhOrder(this.filterQuery)
            .then((response) => {
              this.loading = false;
              if (response.code == 20000) {
                this.$message.success("下载成功");
                this.getList();
              } else {
                this.$message.error(response.message);
              }
            })
            .catch(() => {
              this.loading = false;
            });

        })
        .catch(() => {
        });
    },
  },
  components: {thrInvOrderGenerate},
  mounted() {
  },
  created() {
    this.getBasicThirdSys();
    let end = new Date();
    let start = new Date();
    start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
    this.actDateRange = [moment(start).format('YYYY-MM-DD'), moment(end).format('YYYY-MM-DD')];
  },
};
</script>
<style scoped>
.itemTag {
  float: left;
  text-align: left;
  margin-top: 10px;
  width: 25%;
}

.text {
  font-size: 13px;
  font-family: "Microsoft YaHei";
}

.el-row {
  display: flex;
  flex-wrap: wrap;
}

.el-col {
  border-radius: 4px;
  flex-wrap: wrap;
}
</style>

